



#define	TRAP	nop()


//======================================================================//
#define	BAUD				1000000
#define	BAUD1				1000000
#define	USART_BITS			7			// 5..9 (FTDI 7..9)
#define	USART_PARITY		'n'			// 'n', 'e', 'o'
#define	USART_STOP			1			// 1, 2
//#define	USART_IRQRX
//#define	USART_RXBUF	16			// ! Potega dwjki
//#define	USART_IRQTX
//#define	USART_TXBUF	16			// ! Potega dwjki


#include <rmik/include.h>
#include <rmik/usart.c>


#define	LED			8
#define	SCRLEN		64			// Potga dwjki !!!

byte VideoA[SCRLEN];
byte *scr;
word volatile pozScr;
byte volatile FL_TransEnd=true, FL_Refresh=true;;


#define	SCR_BLACK		0
#define	SCR_RED			0b10000000
#define	SCR_GREEN		0b01000000
#define	SCR_BLUE		0b00100000
#define	SCR_LEMON		SCR_RED + SCR_GREEN
#define	SCR_PURPURE		SCR_RED + SCR_BLUE
#define	SCR_AQUA		SCR_GREEN + SCR_BLUE
#define	SCR_WHITE		SCR_RED + SCR_GREEN + SCR_BLUE


void WS2812B_transcodeRGB(uint8_t green, uint8_t red, uint8_t blue, byte *buffer);   //Przekonwertuj podany kolor w formacie GRB na cig 8 bajtw dla USART
void Refresch();


void Cmd();


//======================================================================//
void main()
{
//todo: zrobic IRQ od WDG
	wdt_enable( WDTO_500MS );			// Ustawienie WDG (IRQ musz byc wyczone)


/*
	DDRD |= _BV(PD5);					// Led Run
	TCCR1A|= (3<<COM1A0) | (1<<WGM10);	// Fast PWM 8-bit
	TCCR1B |= (1<<CS10);				// Podzielnik
*/


	DDRD |= _BV(PD6);		// XOR
	PORTD |= _BV(PD6);

	Usart_Init();
	UBRRH = 0; UBRRL = 0;
	UCSRA |= _BV(U2X);		// W trybie SPI nie ma znaczenia
//	UCSR1C |= (1<<UMSEL10);		// Tryb SYNCHRO (1) nie generuje zegara ???
//UBRR1L = 1;
	UCSRB |= (1<<TXCIE);		// Wczenie przerwa nadawczych
	for(word x=0; x<SCRLEN; x++)
		{
					// EccBBBaaS
		VideoA[x]	= 0b1011011;	// Czarny
		}


	Refresch();
	sei();
	while( true )
		{
		wdg();
		if( FL_TransEnd )
			{
			FL_TransEnd = false;
			Refresch();
			}
		}
}


//======================================================================//
// !!! UWAGA !!!!
// Wszystkie inne przerwania musz byc nie blokowane (INTERRUPT)
//----------------------------------------------------------------------//
SIGNAL(USART_TX_vect)
{
//TODO: Mona zrobic naked i wywali operacja na niewuywanym R1 (3 rozkazy)
// a R0 uy tylko do zachowania na stosie SREG (2 bajty oszczdnoci)


	if ( pozScr )
		{
//		UDR1 = VideoA[pozScr++];
		UDR = *(scr+pozScr++);
		pozScr &=SCRLEN-1;
		}
	if ( pozScr >= SCRLEN ) FL_TransEnd=true;
}



//----------------------------------------------------------------------//
void Refresch()
{
	_delay_us(50);
	pozScr = 1; UDR = *scr;
}


//----------------------------------------------------------------------//
