

//	(C) 2017 R-MIK Sawomir Skrzyski
//	slawomir.skrzynski@ep.com.pl


#ifndef ONEWIRESEARCH_H_
#define	ONEWIRESEARCH_H_


//--------------------------------------------------------------------------
unsigned char LastDiscrepancy;
unsigned char LastFamilyDiscrepancy;
unsigned char LastDeviceFlag;
unsigned char onewireMany;
unsigned int onewireCount;


#ifndef OW_SEARCH_ROM_NO
  unsigned char OW_SEARCH_ROM_NO[8];
#else
  #error "stala?"
#endif
unsigned char docrc8(unsigned char value);
unsigned char crc8;
#define	onewireFirst		OWFirst
#define	onewireNext			OWNext
#define	onewireSearch		OWSearch
#define	onewireHowMuch		OWHowMuch
extern unsigned char OWFirst();			// Szuka adresu pierwszego ukadu
extern unsigned char OWFirstAlert();	// Szuka pierwszego ukadu z alarmem
extern unsigned char OWFirstOVD();		// Szuka pierwszego ukadu obsugujcego overdrive
void OWFi();							// Pomocnicza dla "OWFirstXXXXXXX"
extern unsigned char OWNext();			// Szuka adresu kolejnego ukadu (standard i overdrive)
extern unsigned char OWNextAlert();		// Szuka adresu kolejnego ukadu z alarmem (standard i overdrive)
extern unsigned int  OWHowMuch();		// Zwraca liczb ukadw na magistrali
extern unsigned int  OWHowMuchAlert();	// Zwraca liczb ukadw z alarmem na magistrali
unsigned char OWSearch( byte alarm );	// Wyszukuje jeden ukad, funkcja dla "OWFirstXXXXXXX" i "OWNextXXXXXXX"


//--------------------------------------------------------------------------
#endif